Loading...
Searching...
No Matches
casacore::Muvw Class Reference
measures package (libcasa_measures) » Measures_module

More...

`#include <Muvw.h>`

## Public Types

enum | Types { J2000 , JMEAN , JTRUE , APP , B1950 , B1950_VLA , BMEAN , BTRUE , GALACTIC , HADEC , AZEL , AZELSW , AZELGEO , AZELSWGEO , JNAT , ECLIPTIC , MECLIPTIC , TECLIPTIC , SUPERGAL , ITRF , TOPO , ICRS , N_Types , DEFAULT , AZELNE , AZELNEGEO }
| Types of known Muvws Warning: The order defines the order in the translation matrix FromTo in the getConvert routine; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo, and in showType(); . More...
typedef MVuvw | MVType
| Measure value container for this class (i.e.
typedef MCuvw | MCType
| Measure conversion routines for this class (i.e.
typedef MeasRef< Muvw > | Ref
| Measure reference (i.e.
typedef MeasConvert< Muvw > | Convert
| MeasConvert use (i.e.
typedef ScalarMeasColumn< Muvw > | ScalarColumn
| Measure table Columns (e.g., Muvw::ScalarColumn).
typedef ArrayMeasColumn< Muvw > | ArrayColumn
Public Types inherited from casacore::Measure
enum | Types { N_Types , DEFAULT }
| Each derived class should have a Types enumeration, specifying the recognised frame types. More...
typedef void * | Convert
| Each Measure should have typedefs of the form:

## Public Member Functions

| Muvw ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; Default constructor; generates the ITRF centre
| Muvw (const MVuvw &dt)
| Create from data and reference.
| Muvw (const MVuvw &dt, const Muvw::Ref &rf)
| Muvw (const MVuvw &dt, Muvw::Types rf)
| Muvw (const Measure *dt)
| Muvw (const MeasValue *dt)
| Muvw (const Muvw &)
| Copy constructor and assign.
Muvw & | operator= (const Muvw &)
virtual | ~Muvw ()
virtual const String & | tellMe () const
| Tell me your type.
Bool | giveMe (Muvw::Ref &mr, const String &in)
virtual Bool | setOffset (const Measure &in)
| Set the offset in the reference (False if non-matching Measure).
virtual Bool | setRefString (const String &in)
| Set the reference type to the specified String.
virtual const String & | getDefaultType () const
| Get the default reference type.
virtual const String * | allTypes (Int &nall, Int &nextra, const uInt *&typ) const
| Get a list of all known reference codes.
virtual void | checkTypes () const
| Check if all internal tables of types (both enum and String) are complete and correct.
virtual String | getRefString () const
| Get the reference type (for records, including codes like R_).
Quantum< Vector< Double > > | get (const Unit &inunit) const
| Get Measure data.
Quantum< Vector< Double > > | getAngle () const
Quantum< Vector< Double > > | getAngle (const Unit &inunit) const
virtual Measure * | clone () const
| Make copy.
Public Member Functions inherited from casacore::MeasBase< MVuvw, MeasRef< Muvw > >
| MeasBase ()
| Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference; For reasons of compiler limitations the formal arguments had to be specified as uInt rather than the Measure enums that should be used as actual arguments; Default constructor
MeasBase< MVuvw, MeasRef< Muvw > > & | operator= (const MeasBase< MVuvw, MeasRef< Muvw > > &other)
| Copy assignment.
virtual | ~MeasBase ()
virtual Bool | areYou (const String &tp) const
| Check the type of derived entity.
virtual void | assured (const String &tp) const
| Assert that we are the correct type.
void | set (const MVuvw &dt)
| Refill the specified entities.
virtual Bool | putValue (const Vector< Quantum< Double > > &in)
MeasRef< Muvw > | getRef () const
| Get reference.
const MVuvw & | getValue () const
| Get Measure data.
const Unit & | getUnit () const
| Get Unit.
virtual MRBase * | getRefPtr () const
| Get reference pointer.
virtual const MeasValue * | getData () const
| Get pointer to data.
virtual void | print (std::ostream &os) const
| Print a Measure.
Public Member Functions inherited from casacore::Measure
virtual | ~Measure ()
| Destructor.
virtual void | set (const MeasValue &dt)=0
| Each Measure should have the following set functions (with appropiate MVs and Ref):
virtual Bool | isModel () const
| Tell me if you are a pure model (e.g.
void | dummy_giveMe () const
| Each derived class should have a string-to-code translation routine for the reference type.
void | dummy_getRef () const
| Each class should have a function to return its reference:
void | dummy_getValue () const
| Each derived class should be able to get its internal value and have:

## Static Public Member Functions

static const String & | showMe ()
static void | assure (const Measure &in)
static Muvw::Types | castType (uInt tp)
| Translate reference code.
static const String & | showType (Muvw::Types tp)
static const String & | showType (uInt tp)
static Bool | getType (Muvw::Types &tp, const String &in)
| Translate string to reference code.
static const String * | allMyTypes (Int &nall, Int &nextra, const uInt *&typ)
static void | checkMyTypes ()
static Muvw::Types | fromDirType (const MDirection::Types in)
| Get the correct Muvw type from a given direction type (or v.v.).
static MDirection::Types | toDirType (const Muvw::Types in)
Static Public Member Functions inherited from casacore::Measure
static uInt | giveMe (const String &in, Int N_name, const String tname[])
| A general string checking routine to be used in derived measures.

## Friends

class | MeasConvert< Muvw >
| Conversion of data.

## Additional Inherited Members

Protected Attributes inherited from casacore::MeasBase< MVuvw, MeasRef< Muvw > >
MVuvw | data
| The measure value (e.g.
MeasRef< Muvw > | ref
| Reference frame data.
Unit | unit
| Possible input units.

## Detailed Description

A Measure: uvw on Earth

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMuvw

### Prerequisite

- Measure class

### Etymology

From Measure and uvw

### Synopsis

Muvw is the derived Measure class for an interferometer uvw. uvws can be given in any of the direction types, or as ITRF, the IERS base.
Note that at the moment no correction for Earth tides (error <~ 0.05 mm/km EW uvw), plate motion (not relevant for telescopes on same plate) and relativistic effects are incorporated. B1950 has the same caveat as in MDirection.

### Example

// Specify an Epoch and a telescope position
MEpoch tbm(Quantity(50927.92931, "d"));
MPosition pos(MVPosition(-4750915.84032, 2792906.17778,
-3200483.75028),
MPosition::ITRF);
// Use them in a frame
MeasFrame mf(tbm, pos);
// Specify an uvw (note that values here are in m)
MVuvw mvb0(100,10, 0);
cout << "uvw: " << mvb0 << endl;
// Specify a reference (type and where and when) for the following uvw
Muvw::Ref mbref0(Muvw::ITRF, mf);
Muvw mb0(mvb0, mbref0);
// Show the uvw
cout << "uvw: " << mb0 << endl;
cout << "uvw reference: " << mbref0 << endl;
// Another reference
Muvw::Ref mbref1(Muvw::J2000);
cout << "uvw reference: " << mbref1 << endl;
// Convert the uvw coordinates to the other reference and show it
cout << "Test uvw conversion..." << endl;
Muvw::Convert bconv(mb0, mbref1);
cout << "Converted " << mb0 << endl <<
" to " << mbref1 << endl <<
" as " << bconv() << endl;
casacore::MEpoch
Definition MEpoch.h:101
casacore::MPosition
Definition MPosition.h:76
casacore::MPosition::ITRF
@ ITRF
Definition MPosition.h:92
casacore::MVPosition
Definition MVPosition.h:111
casacore::MVuvw
Definition MVuvw.h:109
casacore::MeasFrame
Definition MeasFrame.h:151
casacore::Muvw::Convert
MeasConvert< Muvw > Convert
MeasConvert use (i.e.
Definition Muvw.h:165
casacore::Muvw::Ref
MeasRef< Muvw > Ref
Measure reference (i.e.
Definition Muvw.h:163
casacore::Muvw::J2000
@ J2000
Definition Muvw.h:128
casacore::Muvw::ITRF
@ ITRF
Definition Muvw.h:147
casacore::Muvw::Muvw
Muvw()
Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measu...
casacore::Quantity
Quantum< Double > Quantity
Definition Quantum.h:39

### Motivation

To be able to handle conversions between uvw coordinates with different reference directions.

### To Do

- EW baselines

Definition at line 112 of file Muvw.h.

## Member Typedef Documentation

## ArrayColumn

typedef ArrayMeasColumn<Muvw> casacore::Muvw::ArrayColumn

Definition at line 168 of file Muvw.h.

## Convert

typedef MeasConvert<Muvw> casacore::Muvw::Convert

MeasConvert use (i.e.

Muvw::Convert)

Definition at line 165 of file Muvw.h.

## MCType

typedef MCuvw casacore::Muvw::MCType

Measure conversion routines for this class (i.e.

Muvw::MCType)

Definition at line 161 of file Muvw.h.

## MVType

typedef MVuvw casacore::Muvw::MVType

Measure value container for this class (i.e.

Muvw::MVType)

Definition at line 159 of file Muvw.h.

## Ref

typedef MeasRef<Muvw> casacore::Muvw::Ref

Measure reference (i.e.

Muvw::Ref)

Definition at line 163 of file Muvw.h.

## ScalarColumn

typedef ScalarMeasColumn<Muvw> casacore::Muvw::ScalarColumn

Measure table Columns (e.g., Muvw::ScalarColumn).

Definition at line 167 of file Muvw.h.

## Member Enumeration Documentation

## Types

enum casacore::Muvw::Types

Types of known Muvws
Warning: The order defines the order in the translation matrix FromTo in the getConvert routine; Do not change the order without changing the array; Additions should be made before N_types, and an additional row and column should be coded in FromTo, and in showType();
.

Enumerator
J2000 |
JMEAN |
JTRUE |
APP |
B1950 |
B1950_VLA |
BMEAN |
BTRUE |
GALACTIC |
HADEC |
AZEL |
AZELSW |
AZELGEO |
AZELSWGEO |
JNAT |
ECLIPTIC |
MECLIPTIC |
TECLIPTIC |
SUPERGAL |
ITRF |
TOPO |
ICRS |
N_Types |
DEFAULT | Defaults.
AZELNE | Synonyms.
AZELNEGEO |

Definition at line 127 of file Muvw.h.

## Constructor & Destructor Documentation

## Muvw() [1/7]

casacore::Muvw::Muvw | ( |  | ) |

Tip: In the following constructors and other functions, all MeasRef can be replaced with simple Measure::TYPE where no offsets or frames are needed in the reference;
Default constructor; generates the ITRF centre

Referenced by MeasConvert< Muvw >, Muvw(), and operator=().

## Muvw() [2/7]

casacore::Muvw::Muvw | ( | const MVuvw & | dt | ) |

Create from data and reference.

## Muvw() [3/7]

casacore::Muvw::Muvw | ( | const MVuvw & | dt,
|  | const Muvw::Ref & | rf )

## Muvw() [4/7]

casacore::Muvw::Muvw | ( | const MVuvw & | dt,
|  | Muvw::Types | rf )

## Muvw() [5/7]

casacore::Muvw::Muvw | ( | const Measure * | dt | ) |

## Muvw() [6/7]

casacore::Muvw::Muvw | ( | const MeasValue * | dt | ) |

## Muvw() [7/7]

casacore::Muvw::Muvw | ( | const Muvw & |  | ) |

Copy constructor and assign.

References Muvw().

## ~Muvw()

virtual casacore::Muvw::~Muvw | ( |  | ) |

virtual

## Member Function Documentation

## allMyTypes()

const String * casacore::Muvw::allMyTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ )

static

## allTypes()

virtual const String * casacore::Muvw::allTypes | ( | Int & | nall,
|  | Int & | nextra,
|  | const uInt *& | typ ) const

virtual

Get a list of all known reference codes.

nall returns the number in list, nextra the number of specials (like planets) that should be at end of list). typ returns the list of corresponding types.

Reimplemented from casacore::Measure.

## assure()

void casacore::Muvw::assure | ( | const Measure & | in | ) |

static

## castType()

Muvw::Types casacore::Muvw::castType | ( | uInt | tp | ) |

static

Translate reference code.

The uInt version has a check for valid codes (i.e. it is a safe cast).

### Thrown Exceptions

- AipsError in the uInt interface if illegal code given

## checkMyTypes()

void casacore::Muvw::checkMyTypes | ( |  | ) |

static

## checkTypes()

virtual void casacore::Muvw::checkTypes | ( |  | ) | const

virtual

Check if all internal tables of types (both enum and String) are complete and correct.

This function is called automatically if and when necessary.

### Thrown Exceptions

- AipsError if a (programming) error in the types.

Implements casacore::Measure.

## clone()

virtual Measure * casacore::Muvw::clone | ( |  | ) | const

virtual

Make copy.

Implements casacore::Measure.

## fromDirType()

Muvw::Types casacore::Muvw::fromDirType | ( | const MDirection::Types | in | ) |

static

Get the correct Muvw type from a given direction type (or v.v.).

## get()

Quantum< Vector< Double > > casacore::Muvw::get | ( | const Unit & | inunit | ) | const

Get Measure data.

## getAngle() [1/2]

Quantum< Vector< Double > > casacore::Muvw::getAngle | ( |  | ) | const

## getAngle() [2/2]

Quantum< Vector< Double > > casacore::Muvw::getAngle | ( | const Unit & | inunit | ) | const

## getDefaultType()

virtual const String & casacore::Muvw::getDefaultType | ( |  | ) | const

virtual

Get the default reference type.

Implements casacore::Measure.

## getRefString()

virtual String casacore::Muvw::getRefString | ( |  | ) | const

virtual

Get the reference type (for records, including codes like R_).

Implements casacore::Measure.

## getType()

Bool casacore::Muvw::getType | ( | Muvw::Types & | tp,
|  | const String & | in )

static

Translate string to reference code.

## giveMe()

Bool casacore::Muvw::giveMe | ( | Muvw::Ref & | mr,
|  | const String & | in )

## operator=()

Muvw & casacore::Muvw::operator= | ( | const Muvw & |  | ) |

References Muvw().

## setOffset()

virtual Bool casacore::Muvw::setOffset | ( | const Measure & | in | ) |

virtual

Set the offset in the reference (False if non-matching Measure).

Implements casacore::Measure.

## setRefString()

virtual Bool casacore::Muvw::setRefString | ( | const String & | in | ) |

virtual

Set the reference type to the specified String.

False if illegal string, reference set to DEFAULT.

Implements casacore::Measure.

## showMe()

const String & casacore::Muvw::showMe | ( |  | ) |

static

## showType() [1/2]

const String & casacore::Muvw::showType | ( | Muvw::Types | tp | ) |

static

## showType() [2/2]

const String & casacore::Muvw::showType | ( | uInt | tp | ) |

static

## tellMe()

virtual const String & casacore::Muvw::tellMe | ( |  | ) | const

virtual

Tell me your type.

Implements casacore::Measure.

## toDirType()

MDirection::Types casacore::Muvw::toDirType | ( | const Muvw::Types | in | ) |

static

## Friends And Related Symbol Documentation

## MeasConvert< Muvw >

friend class MeasConvert< Muvw >

friend

Conversion of data.

Definition at line 1 of file Muvw.h.

References Muvw().

The documentation for this class was generated from the following file:

- measures/Measures/Muvw.h